Vb教程 Vb.net教程 Vfp教程 C/C++教程 Vc/Vc++教程 Delphi教程 Java教程 Powerbuilder
  杀毒频道 | 短信频道 | 网络电视 | 论文中心 | 学上网 | 学软件 | 网页特效 | 电脑基础 | 论坛  
  NCRE | 软考 | CET | 职称英语 | 司法考试 | 报关员 | 公务员 | CATTI | CPA考试  
  Html教程 | Css教程 | Xml教程 | Asp教程 | Asp.net | Php教程 | Jsp教程 | Linux教程 | QQ技巧  
Photoshop Illustrator ImageReady Maya教程 3D Max教程 Lightscape Coredraw教程 Authorware Autocad教程 Freehand教程
Access教程 Mysql教程 Sql server Oracle教程 Word教程 Excel教程 Powerpoint Frontpage Asp.net源码 Php源代码
Flash教程 Fireworks Dreamweaver C#教程 outlook教程 系统安装 vbscript教程 Javascript Jsp源代码 Asp源代码
您的位置:首页 >> Autocad教程 >> 正文

AUTOCAD中自动生成45°视图
文章来源:互联网

 画管路图时,常画俯视图和相应的45°角视图。其实45°角视图中包含的信息只比俯视图中多了每根管路的水平高度。下面这个用LISP编写的程序可以自动将俯视图转化为同一水平高度的45°角视图,使用者只需在转化后的图上将每组管路在竖直方向上移动相应的高度,一幅45°角视图就轻松完成了。

   由于每根管路用一直线表示,所以只需改变直线的起点和终点坐标为相应的45°角视图中的坐标。程序中变量p0记录45°角视图的坐标原点,由用户输入。p1记录直线的起点坐标,p2记录直线的终点坐标。

(defun c:V45( / cmdmode sset ssl ent p0,p1,p2,x1,x2,y0,y1,y2,z1,z2)

(setq cmdmode (getvar "cmdecho"))

(setvar "cmdecho" 0)

;select lines by user

(prompt "\nSelect lines:")

(setq sset (ssget))

(if (not(null sset))

   (progn

    (setq ssl (sslength sset))

    ;input base point by user

    (setq p0 (getpoint "\nThe base point: "))

    (setq y0 (cadr p0))

    (while (> ssl 0)

   (setq ent(entget (ssname sset (setq ssl (1- ssl)))))

   ;filter the lines

   (if (= (cdr (assoc 0 ent)) "LINE")

    ;change the start point and end point of the line

    (progn

      (setq x1 (cadr(assoc 10 ent)))

       (setq y1 (caddr(assoc 10 ent)))

       (setq z1 (cadddr(assoc 10 ent)))

       (setq x2 (cadr(assoc 11 ent)))

       (setq y2 (caddr(assoc 11 ent)))

      (setq z2 (cadddr(assoc 11 ent)))

      (setq p1 (list (+ x1 (/ (* (sqrt 2) (- y1 y0)) 4)) (+ y0 (/ (* (sqrt 2) (- y1 y0))4)) z1))

      (setq p2 (list (+ x2 (/ (* (sqrt 2) (- y2 y0)) 4)) (+ y0 (/ (* (sqrt 2) (- y2 y0))4)) z2))

      (setq ent (entmod (subst (cons 10 p1)

             (assoc 10 ent) ent)))

      (entmod (subst (cons 11 p2)

             (assoc 11 ent) ent))

      (redraw (cdr(assoc -1 ent)) 1))

     )

    )

    )

   )

   (setvar "CMDECHO" cmdmode)

)

(princ "\n\tc:V45 loaded. Start command with V45.")

[返回]

编程语言 web开发 数据库 网络技术 操作系统 服务器 网页设计 图形设计 办公软件 常用软件 学电脑

Copyright© www.bianceng.cn Powered by 编程入门网 All Rights Reserved.
关于本站 | 版权声明 | 联系我们 | 友情链接 |
编程入门网 版权所有